Package org.apache.groovy.ast.tools

# Class ImmutablePropertyUtils

java.lang.Object
org.apache.groovy.ast.tools.ImmutablePropertyUtils

public class ImmutablePropertyUtils extends Object

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final ClassNode`
  `IMMUTABLE_OPTIONS_TYPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static boolean`
  `builtinOrMarkedImmutableClass(Class<?> clazz)`
  `static Expression`
  `cloneArrayOrCloneableExpr(Expression fieldExpr, ClassNode type)`
  `static Expression`
  `cloneDateExpr(Expression origDate)`
  `static String`
  `createErrorMessage(String className, String fieldName, String typeName, String mode)`
  `static boolean`
  `derivesFromDate(ClassNode fieldType)`
  `static List<String>`
  `getKnownImmutableClasses(AbstractASTTransformation xform, ClassNode cNode)`
  `static List<String>`
  `getKnownImmutables(AbstractASTTransformation xform, ClassNode cNode)`
  `static boolean`
  `implementsCloneable(ClassNode fieldType)`
  `static boolean`
  `isBuiltinImmutable(String typeName)`
  `static boolean`
  `isKnownImmutableType(ClassNode fieldType, List<String> knownImmutableClasses)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### IMMUTABLE_OPTIONS_TYPE

    public static final ClassNode IMMUTABLE_OPTIONS_TYPE

- ## Method Details

  - ### cloneArrayOrCloneableExpr

    public static Expression cloneArrayOrCloneableExpr(Expression fieldExpr, ClassNode type)

  - ### implementsCloneable

    public static boolean implementsCloneable(ClassNode fieldType)

  - ### cloneDateExpr

    public static Expression cloneDateExpr(Expression origDate)

  - ### derivesFromDate

    public static boolean derivesFromDate(ClassNode fieldType)

  - ### createErrorMessage

    public static String createErrorMessage(String className, String fieldName, String typeName, String mode)

  - ### isKnownImmutableType

    public static boolean isKnownImmutableType(ClassNode fieldType, List<String> knownImmutableClasses)

  - ### isBuiltinImmutable

    public static boolean isBuiltinImmutable(String typeName)

  - ### builtinOrMarkedImmutableClass

    public static boolean builtinOrMarkedImmutableClass(Class<?> clazz)

  - ### getKnownImmutables

    public static List<String> getKnownImmutables(AbstractASTTransformation xform, ClassNode cNode)

  - ### getKnownImmutableClasses

    public static List<String> getKnownImmutableClasses(AbstractASTTransformation xform, ClassNode cNode)